#ifndef MODULE
#define MODULE
#endif
#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/version.h>
#include <linux/errno.h>

#include <rtl_sched.h>
#include <rtl_fifo.h>
#include "control.h"

static RT_TASK rtl_task;
static MSG msg, rep;

/* t -- the fifo number */
void fun(int t) {
       	while (1) {
		rt_task_suspend(&rtl_task);
		// echo the msg down the pipe
		rtf_put(2, &rep, sizeof(rep));
		}
}

int my_handler(unsigned int fifo)
{

	int err;

	while ((err = rtf_get(1, &msg, sizeof(msg))) == sizeof(msg)) {
		// do something with the msg
		memcpy( &rep, &msg, sizeof(msg));
	        rt_task_wakeup(&rtl_task);
		}
	if (err != 0) {
		return -EINVAL;
	}
	return 0;
}


int init_module(void)
{
	rtf_create(1, 4000); // receiver fifo
	rtf_create(2, 4000); // reply fifo 

	rt_task_init( &rtl_task, fun, 0, 3000, 4);
	rtf_create_handler(1, &my_handler); 
	rt_task_wakeup(&rtl_task);
	return 0;
}


void cleanup_module(void)
{
	rtf_destroy(1);
	rtf_destroy(2);

	rt_task_delete(&rtl_task);
}

