
#include <stdio.h>
#include <errno.h>
#include <sys/time.h>
#include <sys/types.h>
#include <fcntl.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <rtl_fifo.h>
#include <asm/rt_time.h>
#include <sched.h>
#include "control.h"

int main()
{
	fd_set rfds;
        //struct timeval tv;
        int retval;
	int snd, rcv;
	int n;
	int i;
	MSG msg, rep;
        clock_t start, end;	
	struct sched_param sp ;
	int pid ;
	     
	if ((rcv = open("/dev/rtf2", O_RDONLY)) < 0) {
		fprintf(stderr, "Error opening /dev/rtf2\n");
		exit(1);
		}

	if ((snd = open("/dev/rtf1", O_WRONLY)) < 0) {
		fprintf(stderr, "Error opening /dev/rtf1\n");
		exit(1);
		}

	pid = getpid();
	printf( "Linux PID: %d\n", pid);

	i = sched_getparam( pid, &sp );
	printf( "Old Priority: %d\n", sp.sched_priority);

	i = sched_getscheduler( pid );
	printf("Old Scheduler Tactic: %d\n", i );

	sp.sched_priority = 50 ;
	i = sched_setscheduler( pid, SCHED_FIFO, &sp );
	i = sched_getscheduler( pid );
	printf("New Scheduler Tactic: %d\n", i );
	    
	msg.cmd = 0 ;
	strcpy( msg.data, "Hello World Echoed From RTLinux.");

printf("Go (CLOCKS_PER_SEC %d CLK_TCK %d).\n",CLOCKS_PER_SEC, CLK_TCK);
start = clock();	
	for (i = 0 ; i < 60000 ; i++) {
		
		if (write(snd, &msg, sizeof(msg)) < 0) {
			fprintf(stderr, "Can't send msg to rtl_module\n");
			exit(1);
			}
                
		n = read(rcv, &rep, sizeof(rep));
//              if(n) printf("Rcv (%2d): %s\n", n, rep.data );
		if(n != sizeof(rep)) printf("?");

//
//		FD_ZERO(&rfds); 
//		FD_SET(rcv, &rfds);
//		retval = select(FD_SETSIZE, &rfds, NULL, NULL, NULL);
//		if (retval > 0) {
//			if (FD_ISSET(rcv, &rfds)) {
//				n = read(rcv, &rep, sizeof(rep));
//				printf("Rcv: %s\n", rep.data );
//				}
//			}

	}	
end = clock();
printf("Done Elapsed Sec: %5.3f\n", ((double)(end-start))/ ((double)CLOCKS_PER_SEC));
exit(0);
}
